#include <stdio.h>

int f(short, double);  /* prototipo di f */
int g(short, double);  /* prototipo di g */

int main(void)
{
	int (*ptrtof)(short, double);   /* puntatore a funzione dello stesso tipo di f */

	ptrtof = f;                     /* assegno al puntatore l'indirizzo di f */
	printf("%d\n",
		(*ptrtof)(2,3.14)		/* invoco f dereferenziando il puntatore ptrtof */
	);
	ptrtof = g;                     /* assegno al puntatore l'indirizzo di g */
	printf("%d\n",
		(*ptrtof)(2,3.14)		/* invoco f dereferenziando il puntatore ptrtof */
	);              
}

int f(short x, double y)            /* definizione di f */
{
	return y * x;
}

int g(short x, double y)            /* definizione di g */
{
	return x ? y / x : 0;
}
